//
// VIIS.cpp
//
// This file contains pre-compiled scripts for the IIIE Inference Engine

// Standard includes
#include <standard.h>

// Context-dependent includes: 

// Define the constants introduced by this action script.

// GLOBALS

// New Characters

// New Groups

// New Knowledge Base Variables
#define MISSION_SUCCESS (*p_MISSION_SUCCESS)
#define MISSION_FAILURE (*p_MISSION_FAILURE)
#define NEED_TO_BEGIN_MISSION (*p_NEED_TO_BEGIN_MISSION)
#define MISSION_BEGUN (*p_MISSION_BEGUN)
#define MISSION_END (*p_MISSION_END)
#define ALLIES_FOLLOW_ON_HAIL (*p_ALLIES_FOLLOW_ON_HAIL)
#define PLAY_SIMPLE_CINEMATIC (*p_PLAY_SIMPLE_CINEMATIC)
#define CINEMATIC_COMPLETE (*p_CINEMATIC_COMPLETE)
#define CHAT_DEBUG_SWITCH (*p_CHAT_DEBUG_SWITCH)
#define tAlliedHailCheck (*p_tAlliedHailCheck)
#define tDisplayMainTitle (*p_tDisplayMainTitle)
#define tRemoveMainTitle (*p_tRemoveMainTitle)

DllExport hot_int* p_MISSION_SUCCESS;
DllExport hot_int* p_MISSION_FAILURE;
DllExport hot_int* p_NEED_TO_BEGIN_MISSION;
DllExport hot_int* p_MISSION_BEGUN;
DllExport hot_int* p_MISSION_END;
DllExport hot_int* p_ALLIES_FOLLOW_ON_HAIL;
DllExport hot_int* p_PLAY_SIMPLE_CINEMATIC;
DllExport hot_int* p_CINEMATIC_COMPLETE;
DllExport hot_int* p_CHAT_DEBUG_SWITCH;
DllExport timer_int* p_tAlliedHailCheck;
DllExport timer_int* p_tDisplayMainTitle;
DllExport timer_int* p_tRemoveMainTitle;
DllExport bool USE_ALLIED_FLEET;
DllExport bool ALLIED_FLEET_AGGRESSIVE;
DllExport bool ALLIED_FLEET_VISIBLE_TO_ENEMY;
DllExport bool ENEMY_FLEET_VISIBLE_TO_ALLIES;
DllExport bool USE_SIMPLE_CINEMATIC;
DllExport bool NO_FIGHTING_IN_CINEMATIC;
DllExport bool NO_DAMAGE_DURING_CINEMATIC;
DllExport bool vo_overrides_path;
DllExport bool USE_SCRIPT_FAIL_MESSAGE;
DllExport bool DEBUG_CHAT_SWITCH;
DllExport int PLAYER_TEAM;
DllExport int ENEMY_TEAM;
DllExport int ALLIED_FLEET_TEAM;
DllExport int ENEMY_FLEET_TACTICAL_STANCE;
DllExport int TITLE_DISPLAY_START_DELAY;
DllExport int TITLE_DISPLAY_LENGTH;
DllExport int INTRO_TITLE_HORIZ_POSITION;
DllExport int INTRO_TITLE_VRTCL_POSITION;
DllExport float ALLIED_FOLLOW_CHECK_FREQ;
DllExport float camera1_speed;
DllExport float camera1_focus_speed;
DllExport float camera2_speed;
DllExport float camera2_focus_speed;
DllExport float fade_out_delay;
DllExport float fade_out_length;
DllExport float MISSION_SUCCESS_DISPLAY_LENGTH;
DllExport float MISSION_FAIL_DISPLAY_LENGTH;
DllExport Handle vo_playing;
DllExport Handle camera_path1;
DllExport Handle camera_focus1;
DllExport Handle camera_path2;
DllExport Handle camera_focus2;
DllExport Handle Main_Title;
DllExport Handle Main_Title_Shadow;
	
// Special instances.
#define band_selected (*p_band_selected)
#define tried_warp_team_8 (*p_tried_warp_team_8)
#define tried_warp_team_7 (*p_tried_warp_team_7)
#define tried_warp_team_6 (*p_tried_warp_team_6)
#define tried_warp_team_5 (*p_tried_warp_team_5)
#define tried_warp_team_4 (*p_tried_warp_team_4)
#define tried_warp_team_3 (*p_tried_warp_team_3)
#define tried_warp_team_2 (*p_tried_warp_team_2)
#define tried_warp_team_1 (*p_tried_warp_team_1)
#define strength_team_8 (*p_strength_team_8)
#define strength_team_7 (*p_strength_team_7)
#define strength_team_6 (*p_strength_team_6)
#define strength_team_5 (*p_strength_team_5)
#define strength_team_4 (*p_strength_team_4)
#define strength_team_3 (*p_strength_team_3)
#define strength_team_2 (*p_strength_team_2)
#define strength_team_1 (*p_strength_team_1)
#define moons_team_8 (*p_moons_team_8)
#define moons_team_7 (*p_moons_team_7)
#define moons_team_6 (*p_moons_team_6)
#define moons_team_5 (*p_moons_team_5)
#define moons_team_4 (*p_moons_team_4)
#define moons_team_3 (*p_moons_team_3)
#define moons_team_2 (*p_moons_team_2)
#define moons_team_1 (*p_moons_team_1)
#define isCineractiveDone (*p_isCineractiveDone)
#define isCineractiveCancel (*p_isCineractiveCancel)
#define ALWAYS_EVALUATE (*p_ALWAYS_EVALUATE)
#define WORLD (*p_WORLD)

DllExport hot_int* p_band_selected;
DllExport hot_int* p_tried_warp_team_8;
DllExport hot_int* p_tried_warp_team_7;
DllExport hot_int* p_tried_warp_team_6;
DllExport hot_int* p_tried_warp_team_5;
DllExport hot_int* p_tried_warp_team_4;
DllExport hot_int* p_tried_warp_team_3;
DllExport hot_int* p_tried_warp_team_2;
DllExport hot_int* p_tried_warp_team_1;
DllExport hot_float* p_strength_team_8;
DllExport hot_float* p_strength_team_7;
DllExport hot_float* p_strength_team_6;
DllExport hot_float* p_strength_team_5;
DllExport hot_float* p_strength_team_4;
DllExport hot_float* p_strength_team_3;
DllExport hot_float* p_strength_team_2;
DllExport hot_float* p_strength_team_1;
DllExport hot_int* p_moons_team_8;
DllExport hot_int* p_moons_team_7;
DllExport hot_int* p_moons_team_6;
DllExport hot_int* p_moons_team_5;
DllExport hot_int* p_moons_team_4;
DllExport hot_int* p_moons_team_3;
DllExport hot_int* p_moons_team_2;
DllExport hot_int* p_moons_team_1;
DllExport hot_int* p_isCineractiveDone;
DllExport hot_int* p_isCineractiveCancel;
DllExport dirty_int* p_ALWAYS_EVALUATE;
DllExport character* p_WORLD;


// Script Pointer that we use to talk to the game.
// This is why we need no more armada.lib.
//
DllExport ScriptInterface *g_pSI;



//*****************************************************************************
//
// VIIS_load
//
// Load this scripts global variables.
bool VIIS_load(FileReader &fp)
{
	// Assume status is true at start.
	bool status = true;

	// Load global variables.
	status = status && g_pSI->in(fp, &MISSION_SUCCESS);
	status = status && g_pSI->in(fp, &MISSION_FAILURE);
	status = status && g_pSI->in(fp, &NEED_TO_BEGIN_MISSION);
	status = status && g_pSI->in(fp, &MISSION_BEGUN);
	status = status && g_pSI->in(fp, &MISSION_END);
	status = status && g_pSI->in(fp, &ALLIES_FOLLOW_ON_HAIL);
	status = status && g_pSI->in(fp, &PLAY_SIMPLE_CINEMATIC);
	status = status && g_pSI->in(fp, &CINEMATIC_COMPLETE);
	status = status && g_pSI->in(fp, &CHAT_DEBUG_SWITCH);
	status = status && g_pSI->in(fp, &tAlliedHailCheck);
	status = status && g_pSI->in(fp, &tDisplayMainTitle);
	status = status && g_pSI->in(fp, &tRemoveMainTitle);
	status = status && g_pSI->in(fp, &USE_ALLIED_FLEET, sizeof(USE_ALLIED_FLEET));
	status = status && g_pSI->in(fp, &ALLIED_FLEET_AGGRESSIVE, sizeof(ALLIED_FLEET_AGGRESSIVE));
	status = status && g_pSI->in(fp, &ALLIED_FLEET_VISIBLE_TO_ENEMY, sizeof(ALLIED_FLEET_VISIBLE_TO_ENEMY));
	status = status && g_pSI->in(fp, &ENEMY_FLEET_VISIBLE_TO_ALLIES, sizeof(ENEMY_FLEET_VISIBLE_TO_ALLIES));
	status = status && g_pSI->in(fp, &USE_SIMPLE_CINEMATIC, sizeof(USE_SIMPLE_CINEMATIC));
	status = status && g_pSI->in(fp, &NO_FIGHTING_IN_CINEMATIC, sizeof(NO_FIGHTING_IN_CINEMATIC));
	status = status && g_pSI->in(fp, &NO_DAMAGE_DURING_CINEMATIC, sizeof(NO_DAMAGE_DURING_CINEMATIC));
	status = status && g_pSI->in(fp, &vo_overrides_path, sizeof(vo_overrides_path));
	status = status && g_pSI->in(fp, &USE_SCRIPT_FAIL_MESSAGE, sizeof(USE_SCRIPT_FAIL_MESSAGE));
	status = status && g_pSI->in(fp, &DEBUG_CHAT_SWITCH, sizeof(DEBUG_CHAT_SWITCH));
	status = status && g_pSI->in(fp, &PLAYER_TEAM, sizeof(PLAYER_TEAM));
	status = status && g_pSI->in(fp, &ENEMY_TEAM, sizeof(ENEMY_TEAM));
	status = status && g_pSI->in(fp, &ALLIED_FLEET_TEAM, sizeof(ALLIED_FLEET_TEAM));
	status = status && g_pSI->in(fp, &ENEMY_FLEET_TACTICAL_STANCE, sizeof(ENEMY_FLEET_TACTICAL_STANCE));
	status = status && g_pSI->in(fp, &TITLE_DISPLAY_START_DELAY, sizeof(TITLE_DISPLAY_START_DELAY));
	status = status && g_pSI->in(fp, &TITLE_DISPLAY_LENGTH, sizeof(TITLE_DISPLAY_LENGTH));
	status = status && g_pSI->in(fp, &INTRO_TITLE_HORIZ_POSITION, sizeof(INTRO_TITLE_HORIZ_POSITION));
	status = status && g_pSI->in(fp, &INTRO_TITLE_VRTCL_POSITION, sizeof(INTRO_TITLE_VRTCL_POSITION));
	status = status && g_pSI->in(fp, &ALLIED_FOLLOW_CHECK_FREQ, sizeof(ALLIED_FOLLOW_CHECK_FREQ));
	status = status && g_pSI->in(fp, &camera1_speed, sizeof(camera1_speed));
	status = status && g_pSI->in(fp, &camera1_focus_speed, sizeof(camera1_focus_speed));
	status = status && g_pSI->in(fp, &camera2_speed, sizeof(camera2_speed));
	status = status && g_pSI->in(fp, &camera2_focus_speed, sizeof(camera2_focus_speed));
	status = status && g_pSI->in(fp, &fade_out_delay, sizeof(fade_out_delay));
	status = status && g_pSI->in(fp, &fade_out_length, sizeof(fade_out_length));
	status = status && g_pSI->in(fp, &MISSION_SUCCESS_DISPLAY_LENGTH, sizeof(MISSION_SUCCESS_DISPLAY_LENGTH));
	status = status && g_pSI->in(fp, &MISSION_FAIL_DISPLAY_LENGTH, sizeof(MISSION_FAIL_DISPLAY_LENGTH));
	status = status && g_pSI->in(fp, &vo_playing, sizeof(vo_playing));
	status = status && g_pSI->in(fp, &camera_path1, sizeof(camera_path1));
	status = status && g_pSI->in(fp, &camera_focus1, sizeof(camera_focus1));
	status = status && g_pSI->in(fp, &camera_path2, sizeof(camera_path2));
	status = status && g_pSI->in(fp, &camera_focus2, sizeof(camera_focus2));
	status = status && g_pSI->in(fp, &Main_Title, sizeof(Main_Title));
	status = status && g_pSI->in(fp, &Main_Title_Shadow, sizeof(Main_Title_Shadow));

	// Return status.
	return(status);
}



//*****************************************************************************
//
// VIIS_save
//
// Save this scripts global variables.
bool VIIS_save(FileWriter &fp)
{
	// Assume status is true at start.
	bool status = true;

	// Save global variables.
	status = status && g_pSI->out(fp, &MISSION_SUCCESS, "MISSION_SUCCESS");
	status = status && g_pSI->out(fp, &MISSION_FAILURE, "MISSION_FAILURE");
	status = status && g_pSI->out(fp, &NEED_TO_BEGIN_MISSION, "NEED_TO_BEGIN_MISSION");
	status = status && g_pSI->out(fp, &MISSION_BEGUN, "MISSION_BEGUN");
	status = status && g_pSI->out(fp, &MISSION_END, "MISSION_END");
	status = status && g_pSI->out(fp, &ALLIES_FOLLOW_ON_HAIL, "ALLIES_FOLLOW_ON_HAIL");
	status = status && g_pSI->out(fp, &PLAY_SIMPLE_CINEMATIC, "PLAY_SIMPLE_CINEMATIC");
	status = status && g_pSI->out(fp, &CINEMATIC_COMPLETE, "CINEMATIC_COMPLETE");
	status = status && g_pSI->out(fp, &CHAT_DEBUG_SWITCH, "CHAT_DEBUG_SWITCH");
	status = status && g_pSI->out(fp, &tAlliedHailCheck, "tAlliedHailCheck");
	status = status && g_pSI->out(fp, &tDisplayMainTitle, "tDisplayMainTitle");
	status = status && g_pSI->out(fp, &tRemoveMainTitle, "tRemoveMainTitle");
	status = status && g_pSI->out(fp, &USE_ALLIED_FLEET, sizeof(USE_ALLIED_FLEET), "USE_ALLIED_FLEET");
	status = status && g_pSI->out(fp, &ALLIED_FLEET_AGGRESSIVE, sizeof(ALLIED_FLEET_AGGRESSIVE), "ALLIED_FLEET_AGGRESSIVE");
	status = status && g_pSI->out(fp, &ALLIED_FLEET_VISIBLE_TO_ENEMY, sizeof(ALLIED_FLEET_VISIBLE_TO_ENEMY), "ALLIED_FLEET_VISIBLE_TO_ENEMY");
	status = status && g_pSI->out(fp, &ENEMY_FLEET_VISIBLE_TO_ALLIES, sizeof(ENEMY_FLEET_VISIBLE_TO_ALLIES), "ENEMY_FLEET_VISIBLE_TO_ALLIES");
	status = status && g_pSI->out(fp, &USE_SIMPLE_CINEMATIC, sizeof(USE_SIMPLE_CINEMATIC), "USE_SIMPLE_CINEMATIC");
	status = status && g_pSI->out(fp, &NO_FIGHTING_IN_CINEMATIC, sizeof(NO_FIGHTING_IN_CINEMATIC), "NO_FIGHTING_IN_CINEMATIC");
	status = status && g_pSI->out(fp, &NO_DAMAGE_DURING_CINEMATIC, sizeof(NO_DAMAGE_DURING_CINEMATIC), "NO_DAMAGE_DURING_CINEMATIC");
	status = status && g_pSI->out(fp, &vo_overrides_path, sizeof(vo_overrides_path), "vo_overrides_path");
	status = status && g_pSI->out(fp, &USE_SCRIPT_FAIL_MESSAGE, sizeof(USE_SCRIPT_FAIL_MESSAGE), "USE_SCRIPT_FAIL_MESSAGE");
	status = status && g_pSI->out(fp, &DEBUG_CHAT_SWITCH, sizeof(DEBUG_CHAT_SWITCH), "DEBUG_CHAT_SWITCH");
	status = status && g_pSI->out(fp, &PLAYER_TEAM, sizeof(PLAYER_TEAM), "PLAYER_TEAM");
	status = status && g_pSI->out(fp, &ENEMY_TEAM, sizeof(ENEMY_TEAM), "ENEMY_TEAM");
	status = status && g_pSI->out(fp, &ALLIED_FLEET_TEAM, sizeof(ALLIED_FLEET_TEAM), "ALLIED_FLEET_TEAM");
	status = status && g_pSI->out(fp, &ENEMY_FLEET_TACTICAL_STANCE, sizeof(ENEMY_FLEET_TACTICAL_STANCE), "ENEMY_FLEET_TACTICAL_STANCE");
	status = status && g_pSI->out(fp, &TITLE_DISPLAY_START_DELAY, sizeof(TITLE_DISPLAY_START_DELAY), "TITLE_DISPLAY_START_DELAY");
	status = status && g_pSI->out(fp, &TITLE_DISPLAY_LENGTH, sizeof(TITLE_DISPLAY_LENGTH), "TITLE_DISPLAY_LENGTH");
	status = status && g_pSI->out(fp, &INTRO_TITLE_HORIZ_POSITION, sizeof(INTRO_TITLE_HORIZ_POSITION), "INTRO_TITLE_HORIZ_POSITION");
	status = status && g_pSI->out(fp, &INTRO_TITLE_VRTCL_POSITION, sizeof(INTRO_TITLE_VRTCL_POSITION), "INTRO_TITLE_VRTCL_POSITION");
	status = status && g_pSI->out(fp, &ALLIED_FOLLOW_CHECK_FREQ, sizeof(ALLIED_FOLLOW_CHECK_FREQ), "ALLIED_FOLLOW_CHECK_FREQ");
	status = status && g_pSI->out(fp, &camera1_speed, sizeof(camera1_speed), "camera1_speed");
	status = status && g_pSI->out(fp, &camera1_focus_speed, sizeof(camera1_focus_speed), "camera1_focus_speed");
	status = status && g_pSI->out(fp, &camera2_speed, sizeof(camera2_speed), "camera2_speed");
	status = status && g_pSI->out(fp, &camera2_focus_speed, sizeof(camera2_focus_speed), "camera2_focus_speed");
	status = status && g_pSI->out(fp, &fade_out_delay, sizeof(fade_out_delay), "fade_out_delay");
	status = status && g_pSI->out(fp, &fade_out_length, sizeof(fade_out_length), "fade_out_length");
	status = status && g_pSI->out(fp, &MISSION_SUCCESS_DISPLAY_LENGTH, sizeof(MISSION_SUCCESS_DISPLAY_LENGTH), "MISSION_SUCCESS_DISPLAY_LENGTH");
	status = status && g_pSI->out(fp, &MISSION_FAIL_DISPLAY_LENGTH, sizeof(MISSION_FAIL_DISPLAY_LENGTH), "MISSION_FAIL_DISPLAY_LENGTH");
	status = status && g_pSI->out(fp, &vo_playing, sizeof(vo_playing), "vo_playing");
	status = status && g_pSI->out(fp, &camera_path1, sizeof(camera_path1), "camera_path1");
	status = status && g_pSI->out(fp, &camera_focus1, sizeof(camera_focus1), "camera_focus1");
	status = status && g_pSI->out(fp, &camera_path2, sizeof(camera_path2), "camera_path2");
	status = status && g_pSI->out(fp, &camera_focus2, sizeof(camera_focus2), "camera_focus2");
	status = status && g_pSI->out(fp, &Main_Title, sizeof(Main_Title), "Main_Title");
	status = status && g_pSI->out(fp, &Main_Title_Shadow, sizeof(Main_Title_Shadow), "Main_Title_Shadow");

	// Return status.
	return(status);
}



//*****************************************************************************
//
// VIIS_script_preinit
//
// Create the script class variables for this rule set.
void VIIS_script_preinit()
{
	 
	script_ptr the_script = NULL;
	 

	// Init file operations.
	g_pSI->AddToLoad(VIIS_load);
	g_pSI->AddToSave(VIIS_save);


	// Construct the pointer based variables introduced by this script.
	p_MISSION_SUCCESS = g_pSI->ScriptCreate_hot_int("MISSION_SUCCESS");
	p_MISSION_FAILURE = g_pSI->ScriptCreate_hot_int("MISSION_FAILURE");
	p_NEED_TO_BEGIN_MISSION = g_pSI->ScriptCreate_hot_int("NEED_TO_BEGIN_MISSION");
	p_MISSION_BEGUN = g_pSI->ScriptCreate_hot_int("MISSION_BEGUN");
	p_MISSION_END = g_pSI->ScriptCreate_hot_int("MISSION_END");
	p_ALLIES_FOLLOW_ON_HAIL = g_pSI->ScriptCreate_hot_int("ALLIES_FOLLOW_ON_HAIL");
	p_PLAY_SIMPLE_CINEMATIC = g_pSI->ScriptCreate_hot_int("PLAY_SIMPLE_CINEMATIC");
	p_CINEMATIC_COMPLETE = g_pSI->ScriptCreate_hot_int("CINEMATIC_COMPLETE");
	p_CHAT_DEBUG_SWITCH = g_pSI->ScriptCreate_hot_int("CHAT_DEBUG_SWITCH");
	p_tAlliedHailCheck = g_pSI->ScriptCreate_timer_int("tAlliedHailCheck");
	p_tDisplayMainTitle = g_pSI->ScriptCreate_timer_int("tDisplayMainTitle");
	p_tRemoveMainTitle = g_pSI->ScriptCreate_timer_int("tRemoveMainTitle");


	// Get the special instance variables.
	p_band_selected = g_pSI->ScriptGet_band_selected();
	p_tried_warp_team_8 = g_pSI->ScriptGet_tried_warp_team_8();
	p_tried_warp_team_7 = g_pSI->ScriptGet_tried_warp_team_7();
	p_tried_warp_team_6 = g_pSI->ScriptGet_tried_warp_team_6();
	p_tried_warp_team_5 = g_pSI->ScriptGet_tried_warp_team_5();
	p_tried_warp_team_4 = g_pSI->ScriptGet_tried_warp_team_4();
	p_tried_warp_team_3 = g_pSI->ScriptGet_tried_warp_team_3();
	p_tried_warp_team_2 = g_pSI->ScriptGet_tried_warp_team_2();
	p_tried_warp_team_1 = g_pSI->ScriptGet_tried_warp_team_1();
	p_strength_team_8 = g_pSI->ScriptGet_strength_team_8();
	p_strength_team_7 = g_pSI->ScriptGet_strength_team_7();
	p_strength_team_6 = g_pSI->ScriptGet_strength_team_6();
	p_strength_team_5 = g_pSI->ScriptGet_strength_team_5();
	p_strength_team_4 = g_pSI->ScriptGet_strength_team_4();
	p_strength_team_3 = g_pSI->ScriptGet_strength_team_3();
	p_strength_team_2 = g_pSI->ScriptGet_strength_team_2();
	p_strength_team_1 = g_pSI->ScriptGet_strength_team_1();
	p_moons_team_8 = g_pSI->ScriptGet_moons_team_8();
	p_moons_team_7 = g_pSI->ScriptGet_moons_team_7();
	p_moons_team_6 = g_pSI->ScriptGet_moons_team_6();
	p_moons_team_5 = g_pSI->ScriptGet_moons_team_5();
	p_moons_team_4 = g_pSI->ScriptGet_moons_team_4();
	p_moons_team_3 = g_pSI->ScriptGet_moons_team_3();
	p_moons_team_2 = g_pSI->ScriptGet_moons_team_2();
	p_moons_team_1 = g_pSI->ScriptGet_moons_team_1();
	p_isCineractiveDone = g_pSI->ScriptGet_isCineractiveDone();
	p_isCineractiveCancel = g_pSI->ScriptGet_isCineractiveCancel();
	p_ALWAYS_EVALUATE = g_pSI->ScriptGet_ALWAYS_EVALUATE();
	p_WORLD = g_pSI->ScriptGet_WORLD();


}



//*****************************************************************************
//
// VIIS_script_init
//
// Initialize the data for this rule set load assets.
void VIIS_script_init()
{
	 
	script_ptr the_script = NULL;
	 
	NEED_TO_BEGIN_MISSION = 0 ;
	MISSION_BEGUN = 0 ;
	MISSION_SUCCESS = 0 ;
	MISSION_FAILURE = 0 ;
	MISSION_END = 0 ;
	PLAYER_TEAM = 1 ;
	ENEMY_TEAM = 2 ;
	isCineractiveCancel = false ;
	isCineractiveDone = false ;
	INTRO_TITLE_HORIZ_POSITION = 498 ;
	INTRO_TITLE_VRTCL_POSITION = 100 ;
	TITLE_DISPLAY_START_DELAY = 3 ;
	TITLE_DISPLAY_LENGTH = 9 ;
	MISSION_SUCCESS_DISPLAY_LENGTH = 7.0 ;
	MISSION_FAIL_DISPLAY_LENGTH = 7.0 ;
	USE_SCRIPT_FAIL_MESSAGE = false ;
	USE_ALLIED_FLEET = false ;
	ALLIED_FLEET_TEAM = 3 ;
	ALLIED_FLEET_AGGRESSIVE = false ;
	ALLIES_FOLLOW_ON_HAIL = false ;
	ALLIED_FOLLOW_CHECK_FREQ = 0.5 ;
	ALLIED_FLEET_VISIBLE_TO_ENEMY = false ;
	ENEMY_FLEET_TACTICAL_STANCE = 0 ;
	ENEMY_FLEET_VISIBLE_TO_ALLIES = false ;
	USE_SIMPLE_CINEMATIC = true ;
	NO_FIGHTING_IN_CINEMATIC = true ;
	NO_DAMAGE_DURING_CINEMATIC = true ;
	CINEMATIC_COMPLETE = ! USE_SIMPLE_CINEMATIC ;
	camera1_speed = 1.5f ;
	camera1_focus_speed = 1.5f ;
	camera2_speed = 0.5f ;
	camera2_focus_speed = 0.5f ;
	fade_out_delay = 15.0f ;
	fade_out_length = 6.0f ;
	vo_overrides_path = false ;
	DEBUG_CHAT_SWITCH = false ;
	if ( USE_SIMPLE_CINEMATIC ) { NEED_TO_BEGIN_MISSION = 0 ;
	PLAY_SIMPLE_CINEMATIC = 1 ;
	} else { NEED_TO_BEGIN_MISSION = 1 ;
	PLAY_SIMPLE_CINEMATIC = 0 ;
	};
	
}



//*****************************************************************************
//
// VIIS_script_trash
//
// Signal that we are leaving this script & clean up.
void VIIS_script_trash()
{
	// Trash file operations.
	g_pSI->RemoveFromLoad(VIIS_load);
	g_pSI->RemoveFromSave(VIIS_save);


	// Destroy the pointer based variables introduced by this script.
	g_pSI->ScriptDestroy_hot_int(p_MISSION_SUCCESS);
	g_pSI->ScriptDestroy_hot_int(p_MISSION_FAILURE);
	g_pSI->ScriptDestroy_hot_int(p_NEED_TO_BEGIN_MISSION);
	g_pSI->ScriptDestroy_hot_int(p_MISSION_BEGUN);
	g_pSI->ScriptDestroy_hot_int(p_MISSION_END);
	g_pSI->ScriptDestroy_hot_int(p_ALLIES_FOLLOW_ON_HAIL);
	g_pSI->ScriptDestroy_hot_int(p_PLAY_SIMPLE_CINEMATIC);
	g_pSI->ScriptDestroy_hot_int(p_CINEMATIC_COMPLETE);
	g_pSI->ScriptDestroy_hot_int(p_CHAT_DEBUG_SWITCH);
	g_pSI->ScriptDestroy_timer_int(p_tAlliedHailCheck);
	g_pSI->ScriptDestroy_timer_int(p_tDisplayMainTitle);
	g_pSI->ScriptDestroy_timer_int(p_tRemoveMainTitle);

}



//*****************************************************************************
//
// VIIS_script_entry
//
// Entry routine for the VIIS script library



//
// VIIS_rules_entry
//
// Entry routine for the VIIS rules library
int WINAPI DllMain(HANDLE hModule,
	DWORD ul_reason_for_call,
	LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		break;
	case DLL_PROCESS_DETACH:
		VIIS_script_trash();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	default : break;
	}
	return(TRUE);
}



//*****************************************************************************
//
// Script Extend Interface
//
// Where the game extends the script interface to the script
// and we see if our version is out of date.
 // extern "C" so we get a nice name for GetProcAddress
// We pass back the version we were built with, so the app can compare

extern "C" __declspec( dllexport ) int ScriptExtendInterface(ScriptInterface *pSI,int lastCompatibleVersion)
{
	g_pSI = pSI;
	
	// If out of date, exit immediately so we don't call bad pointers.
	if (SI_CURRENT_VERSION != lastCompatibleVersion)
		return SI_CURRENT_VERSION;

	// Create the script variables and grab the globals
	VIIS_script_preinit();
	
	return SI_CURRENT_VERSION;
}


// VERBATIMS.
// These were blocks of raw code we just substitute script method names
// So that the calls are all made properly.




//*****************************************************************************
//
// Script Init
//
// The main init routine for the script library
// Really sets up the game
// 
// extern "C" so we get a nice name for GetProcAddress

extern "C" __declspec( dllexport ) void ScriptInit()
{
	VIIS_script_init();
}


// ACTION_SCRIPTS.



//*****************************************************************************
// Steps for action Start_Mission.

// WORLD's steps


//
// WORLD_Start_Mission_step_1
//
// Step 1 of action "Start_Mission" for WORLD
int WORLD_Start_Mission_step_1(script_ptr the_script)
{
	Handle hTmpHandle ;
	int iUnits ;
	NEED_TO_BEGIN_MISSION = 0 ;
	MISSION_BEGUN = 1 ;
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	tDisplayMainTitle.start ( TITLE_DISPLAY_START_DELAY );
	tRemoveMainTitle.start ( TITLE_DISPLAY_LENGTH );
	g_pSI->DisableAllAITeams ();
	g_pSI->JukeBoxPlaySpecific ( "ST_FireStormBattle2.ogg" );
	g_pSI->JukeBoxAddCustomMusic ("ST_PicardLight.wav", 1 , 0 , 1.0f , true );
	g_pSI->JukeBoxAddCustomMusic ("ST_KlingonTheme.wav", 2 , 0 , 1.0f , true );
	g_pSI->JukeBoxAddCustomMusic ("ST_FED_Victory.wav", 3 , 1 , 1.0f , false );
	g_pSI->JukeBoxAddCustomMusic ("ST_FED_ShipLost.wav", 3 , 2 , 1.0f , false );
	g_pSI->JukeBoxAddCustomMusic ("ST_FED_ShipLost.wav", 3 , 3 , 1.0f , false );
	g_pSI->JukeBoxEnableDynamicMusic ();
	g_pSI->JukeBoxSetUseCustomMusic ( true );
	g_pSI->AllowDamage ( - 1 , true );
	if ( NO_FIGHTING_IN_CINEMATIC )
	{
	g_pSI->SetRelation ( PLAYER_TEAM , ENEMY_TEAM , TEAM_ENEMY );
	g_pSI->SetRelation ( ENEMY_TEAM , PLAYER_TEAM , TEAM_ENEMY );
	};
	if ( USE_ALLIED_FLEET )
	{
	g_pSI->SetRelation ( PLAYER_TEAM , ALLIED_FLEET_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( ALLIED_FLEET_TEAM , PLAYER_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( ENEMY_TEAM , ALLIED_FLEET_TEAM , TEAM_ENEMY );
	g_pSI->SetRelation ( ALLIED_FLEET_TEAM , ENEMY_TEAM , TEAM_ENEMY );
	if ( ALLIED_FLEET_AGGRESSIVE )
	{
	iUnits = g_pSI->CountUnits ( ALLIED_FLEET_TEAM );
	for ( int iCnt = 0 ;
	iCnt < iUnits ;
	iCnt ++)
	{
	hTmpHandle = g_pSI->GetCraftFromTeamList ( ALLIED_FLEET_TEAM , iCnt );
	g_pSI->SetTactics ( hTmpHandle , TACTICS_AGGRESSIVE );
	if ( ALLIED_FLEET_VISIBLE_TO_ENEMY ) g_pSI->SetCraftVisibleToTeam ( hTmpHandle , ENEMY_TEAM , true );
	};
	};
	if ( ALLIES_FOLLOW_ON_HAIL ) tAlliedHailCheck.start ( ALLIED_FOLLOW_CHECK_FREQ );
	};
	iUnits = g_pSI->CountUnits ( ENEMY_TEAM );
	for ( int iCnt = 0 ;
	iCnt < iUnits ;
	iCnt ++)
	{
	hTmpHandle = g_pSI->GetCraftFromTeamList ( ENEMY_TEAM , iCnt );
	switch ( ENEMY_FLEET_TACTICAL_STANCE )
	{
	case 0 : g_pSI->SetTactics ( hTmpHandle , TACTICS_AGGRESSIVE );
	break ;
	case 1 : g_pSI->SetTactics ( hTmpHandle , TACTICS_DEFENSIVE );
	break ;
	}
	if ( USE_ALLIED_FLEET && ENEMY_FLEET_VISIBLE_TO_ALLIES ) g_pSI->SetCraftVisibleToTeam ( hTmpHandle , ALLIED_FLEET_TEAM , true );
	};
	g_pSI->ObjectivesDisplay_LoadXmlFile ("VII_Objectives.xml");
	g_pSI->ObjectivesDisplay_Set_Visibility ( true );
	
	return(0);
}



//
// Start_Mission
//
// Action script for action Start_Mission
DllExport void Start_Mission()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Start_Mission\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Start_Mission");

	the_script->add_step(WORLD_Start_Mission_step_1);

}



//*****************************************************************************
// Steps for action Check_Allied_Fleet_Hails.

// WORLD's steps


//
// WORLD_Check_Allied_Fleet_Hails_step_1
//
// Step 1 of action "Check_Allied_Fleet_Hails" for WORLD
int WORLD_Check_Allied_Fleet_Hails_step_1(script_ptr the_script)
{
	int iCnt ;
	Handle hAlliedShip ;
	Handle hPlayerShip ;
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	for ( iCnt = 0 ;
	iCnt < g_pSI->CountUnits ( ALLIED_FLEET_TEAM );
	iCnt ++)
	{
	hAlliedShip = g_pSI->GetCraftFromTeamList ( ALLIED_FLEET_TEAM , iCnt );
	if ( g_pSI->IsUsed ( g_pSI->GetCraftFromTeamList ( ALLIED_FLEET_TEAM , iCnt ), kUseType_Hail ))
	{
	hPlayerShip = g_pSI->WhoUsed ( g_pSI->GetCraftFromTeamList ( ALLIED_FLEET_TEAM , iCnt ), kUseType_Hail );
	g_pSI->SetTactics ( hAlliedShip , TACTICS_DEFENSIVE );
	g_pSI->SetCommandWhatWhoVO ( hAlliedShip , CMD_GUARD , hPlayerShip );
	g_pSI->ResetUse ( hAlliedShip , kUseType_Hail );
	g_pSI->AudioMessage ( the_script, "f_cap14_Crew_ack_3.wav", true );
	}
	} if ( ALLIES_FOLLOW_ON_HAIL && USE_ALLIED_FLEET ) tAlliedHailCheck.start ( ALLIED_FOLLOW_CHECK_FREQ );
	
	return(0);
}



//
// Check_Allied_Fleet_Hails
//
// Action script for action Check_Allied_Fleet_Hails
DllExport void Check_Allied_Fleet_Hails()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Check_Allied_Fleet_Hails\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Check_Allied_Fleet_Hails");

	the_script->add_step(WORLD_Check_Allied_Fleet_Hails_step_1);

}



//*****************************************************************************
// Steps for action Mission_Success.

// WORLD's steps


//
// WORLD_Mission_Success_step_1
//
// Step 1 of action "Mission_Success" for WORLD
int WORLD_Mission_Success_step_1(script_ptr the_script)
{
	MISSION_END = 1 ;
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	g_pSI->JukeBoxPlaySpecificEventMusic ("ST_FED_ShipLost.ogg");
	g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 , "Mission Successful!");
	g_pSI->SucceedMission ( g_pSI->GetTime () + MISSION_SUCCESS_DISPLAY_LENGTH );
	
	return(0);
}



//
// Mission_Success
//
// Action script for action Mission_Success
DllExport void Mission_Success()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Mission_Success\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Mission_Success");

	the_script->add_step(WORLD_Mission_Success_step_1);

}



//*****************************************************************************
// Steps for action Mission_Fail.

// WORLD's steps


//
// WORLD_Mission_Fail_step_1
//
// Step 1 of action "Mission_Fail" for WORLD
int WORLD_Mission_Fail_step_1(script_ptr the_script)
{
	MISSION_END = 1 ;
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	g_pSI->JukeBoxPlaySpecificEventMusic ("ST_FED_ShipLost.ogg");
	if ( USE_SCRIPT_FAIL_MESSAGE ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 , "Mission Failed!");
	g_pSI->FailMission ( g_pSI->GetTime () + MISSION_FAIL_DISPLAY_LENGTH );
	
	return(0);
}



//
// Mission_Fail
//
// Action script for action Mission_Fail
DllExport void Mission_Fail()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Mission_Fail\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Mission_Fail");

	the_script->add_step(WORLD_Mission_Fail_step_1);

}



//*****************************************************************************
// Steps for action Play_Cinematic.

// WORLD's steps


//
// WORLD_Play_Cinematic_step_1
//
// Step 1 of action "Play_Cinematic" for WORLD
int WORLD_Play_Cinematic_step_1(script_ptr the_script)
{
	PLAY_SIMPLE_CINEMATIC = 0 ;
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	g_pSI->AllowDamage (- 1 , ! NO_DAMAGE_DURING_CINEMATIC );
	if ( USE_ALLIED_FLEET )
	{
	g_pSI->SetRelation ( PLAYER_TEAM , ALLIED_FLEET_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( ALLIED_FLEET_TEAM , PLAYER_TEAM , TEAM_ALLY );
	};
	if ( NO_FIGHTING_IN_CINEMATIC )
	{
	g_pSI->SetRelation ( PLAYER_TEAM , ENEMY_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( ENEMY_TEAM , PLAYER_TEAM , TEAM_ALLY );
	if ( USE_ALLIED_FLEET )
	{
	g_pSI->SetRelation ( ALLIED_FLEET_TEAM , ENEMY_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( ALLIED_FLEET_TEAM , PLAYER_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( PLAYER_TEAM , ALLIED_FLEET_TEAM , TEAM_ALLY );
	g_pSI->SetRelation ( ENEMY_TEAM , ALLIED_FLEET_TEAM , TEAM_ALLY );
	};
	};
	camera_path1 = g_pSI->GetHandle ("camera_path1");
	camera_focus1 = g_pSI->GetHandle ("camera_focus1");
	camera_path2 = g_pSI->GetHandle ("camera_path1");
	camera_focus2 = g_pSI->GetHandle ("camera_focus1");
	g_pSI->FadeIn ( the_script, 3.0f , 0.0f );
	g_pSI->CineractiveStart ( the_script, true );
	g_pSI->CineractiveShot ( the_script, "camera_path1", camera1_speed , "camera_focus1", camera1_focus_speed );
	g_pSI->CineractiveConstantSpeed ( true );
	g_pSI->FadeOut ( the_script, fade_out_length , fade_out_delay );
	vo_playing = g_pSI->AudioMessage ( the_script, "", vo_overrides_path );
	
	return(0);
}



//
// WORLD_Play_Cinematic_step_2
//
// Step 2 of action "Play_Cinematic" for WORLD
int WORLD_Play_Cinematic_step_2(script_ptr the_script)
{
	g_pSI->FadeIn ( the_script, 3.0f , 0.0f );
	g_pSI->CineractiveStart ( the_script, true );
	g_pSI->CineractiveShot ( the_script, "camera_path2", camera2_speed , "camera_focus2", camera2_focus_speed );
	g_pSI->CineractiveConstantSpeed ( true );
	g_pSI->FadeOut ( the_script, fade_out_length , fade_out_delay );
	vo_playing = g_pSI->AudioMessage ( the_script, "", vo_overrides_path );
	
	return(0);
}



//
// WORLD_Play_Cinematic_step_3
//
// Step 3 of action "Play_Cinematic" for WORLD
int WORLD_Play_Cinematic_step_3(script_ptr the_script)
{
	g_pSI->CineractiveEnd ();
	g_pSI->StopAudioMessage ( vo_playing );
	NEED_TO_BEGIN_MISSION = 1 ;
	
	return(0);
}



//
// Play_Cinematic
//
// Action script for action Play_Cinematic
DllExport void Play_Cinematic()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Play_Cinematic\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Play_Cinematic");

	the_script->add_step(WORLD_Play_Cinematic_step_1);
	the_script->add_step(WORLD_Play_Cinematic_step_2);
	the_script->add_step(WORLD_Play_Cinematic_step_3);

}



//*****************************************************************************
// Steps for action Display_Main_Title.

// WORLD's steps


//
// WORLD_Display_Main_Title_step_1
//
// Step 1 of action "Display_Main_Title" for WORLD
int WORLD_Display_Main_Title_step_1(script_ptr the_script)
{
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	Main_Title_Shadow = g_pSI->ShowTitle ( INTRO_TITLE_HORIZ_POSITION , INTRO_TITLE_VRTCL_POSITION , "VII_TITLE", 0.1f , 0.1f , 0.1f , true );
	Main_Title = g_pSI->ShowTitle ( INTRO_TITLE_HORIZ_POSITION + 2 , INTRO_TITLE_VRTCL_POSITION + 2 , "VII_TITLE", 0.0f , 0.5f , 1.0f , true );
	
	return(0);
}



//
// Display_Main_Title
//
// Action script for action Display_Main_Title
DllExport void Display_Main_Title()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Display_Main_Title\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Display_Main_Title");

	the_script->add_step(WORLD_Display_Main_Title_step_1);

}



//*****************************************************************************
// Steps for action Remove_Main_Title.

// WORLD's steps


//
// WORLD_Remove_Main_Title_step_1
//
// Step 1 of action "Remove_Main_Title" for WORLD
int WORLD_Remove_Main_Title_step_1(script_ptr the_script)
{
	if ( CHAT_DEBUG_SWITCH ) g_pSI->ShowChatMessage ( 1.0 , 1.0 , 1.0 ,"");
	g_pSI->RemoveTitle ( Main_Title );
	g_pSI->RemoveTitle ( Main_Title_Shadow );
	
	return(0);
}



//
// Remove_Main_Title
//
// Action script for action Remove_Main_Title
DllExport void Remove_Main_Title()
{
#ifdef DEBUG
	Log_Message("\n\tACTION: Remove_Main_Title\n");
#endif

	 
	script_ptr the_script;
	 

	the_script = WORLD.new_script("WORLD_Remove_Main_Title");

	the_script->add_step(WORLD_Remove_Main_Title_step_1);

}
